 
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

#include "bignum.h"
#include "print.h"

#define BNUM_MASK	0xFFFF

static void print_time(struct timeval *start,struct timeval *stop);

void
test_spof_kmul()
{
	int i, size, res;
	unsigned short *largenum;
	
	struct bignum *a, *b, *c, *c2;
	struct timeval tvstart, tvstop;

	a = bnum_new();
	b = bnum_new();
	c = bnum_new();
	c2 = bnum_new();
	
	printf("Please input number of blocks\n");
	res = scanf("%d", &size);
	
	if (res  == 0) {
		printf("INPUT ERROR\n");
		exit(1);
	}
	
	largenum = malloc(size * sizeof(unsigned short));
	
	if (largenum == NULL) {
		perror("malloc");
		exit( BIGNUM_NOMEM);
	}
	
	i = 0;
	for (i = 0; i<size; i++) 
		largenum[i] = BNUM_MASK;
	
	bnum_set_safe(a, largenum, size, 0);
	bnum_set_safe(b, largenum, size, 0);

	printf("size = %d \n", size);
	printf("\n=====================================\n");
	printf("mul time is:\n");
	
	gettimeofday(&tvstart, NULL);
	bnum_mul(c, a, b);
	gettimeofday(&tvstop, NULL);

	print_time(&tvstart, &tvstop);

	printf("\nkmul time is:\n");
	
	gettimeofday(&tvstart, NULL);
	bnum_kmul(c2, a, b);
	gettimeofday(&tvstop, NULL);

	print_time(&tvstart, &tvstop);
	
	printf("equivalent? (%d)", !bnum_cmp(c, c2));
	
	printf("\n=====================================\n");
	free(largenum);
	bnum_free(&c);
	bnum_free(&a);
	bnum_free(&b);
}

int
main(int argc, char *argv[])
{
	test_spof_kmul();

	return 0;
}


static void print_time(struct timeval *start,struct timeval *stop) 
{
	int nflg;
	unsigned int tmp;
	nflg = 0;
	if (start->tv_usec > stop->tv_usec)
		nflg = 1;
	tmp = stop->tv_sec - start->tv_sec - nflg;
	printf(" %u  ", tmp);
	tmp = stop->tv_usec - start->tv_usec;
	printf(" %u  ", tmp);
}
